# all files / ol/ proj.js

47.06% Statements 72/153
23.08% Branches 15/65
51.85% Functions 14/27
47.06% Lines 72/153

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383
    384
    385
    386
    387
    388
    389
    390
    391
    392
    393
    394
    395
    396
    397
    398
    399
    400
    401
    402
    403
    404
    405
    406
    407
    408
    409
    410
    411
    412
    413
    414
    415
    416
    417
    418
    419
    420
    421
    422
    423
    424
    425
    426
    427
    428
    429
    430
    431
    432
    433
    434
    435
    436
    437
    438
    439
    440
    441
    442
    443
    444
    445
    446
    447
    448
    449
    450
    451
    452
    453
    454
    455
    456
    457
    458
    459
    460
    461
    462
    463
    464
    465
    466
    467
    468
    469
    470
    471
    472
    473
    474
    475
    476
    477
    478
    479
    480
    481
    482
    483
    484
    485
    486
    487
    488
    489
    490
    491
    492
    493
    494
    495
    496
    497
    498
    499
    500
    501
    502
    503
    504
    505
    506
    507
    5081×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×
    2×
    2×
    15×
    113×
    98×

    1×
    1×
    8×
    56×
    56×

    1×
    15×
    15×

    1×
    2×

    1×

    1×

    1×

    1×

    1×
    1×

    1×

    1×
    19×
    19×
    2×
    17×
    15×
    15×
    15×

    19×

    1×

    1×
    2×
    2×
    2×

    1×
    2×
    2×
    2×
    2×

    2×

    2×

    1×

    1×

    1×
    2×
    2×

    1×

    1×

    1×

    1×
    1×

    1×

    1×
     goog.provide('ol.proj');

    goog.require('ol');
    goog.require('ol.Sphere');
    goog.require('ol.extent');
    goog.require('ol.proj.EPSG3857');
    goog.require('ol.proj.EPSG4326');
    goog.require('ol.proj.Projection');
    goog.require('ol.proj.Units');
    goog.require('ol.proj.proj4');
    goog.require('ol.proj.projections');
    goog.require('ol.proj.transforms');

    /**
     * Meters per unit lookup table.
     * @const
     * @type {Object.<ol.proj.Units, number>}
     * @api
     */
    ol.proj.METERS_PER_UNIT = ol.proj.Units.METERS_PER_UNIT;

    /**
     * A place to store the mean radius of the Earth.
     * @private
     * @type {ol.Sphere}
     */
    ol.proj.SPHERE_ = new ol.Sphere(ol.Sphere.DEFAULT_RADIUS);

    Eif (ol.ENABLE_PROJ4JS) {
      /**
       * Register proj4. If not explicitly registered, it will be assumed that
       * proj4js will be loaded in the global namespace. For example in a
       * browserify ES6 environment you could use:
       *
       *     import ol from 'openlayers';
       *     import proj4 from 'proj4';
       *     ol.proj.setProj4(proj4);
       *
       * @param {Proj4} proj4 Proj4.
       * @api
       */
      ol.proj.setProj4 = function(proj4) {
        ol.proj.proj4.set(proj4);
      };
    }

    /**
     * Get the resolution of the point in degrees or distance units.
     * For projections with degrees as the unit this will simply return the
     * provided resolution. For other projections the point resolution is
     * by default estimated by transforming the 'point' pixel to EPSG:4326,
     * measuring its width and height on the normal sphere,
     * and taking the average of the width and height.
     * A custom function can be provided for a specific projection, either
     * by setting the `getPointResolution` option in the
     * {@link ol.proj.Projection} constructor or by using
     * {@link ol.proj.Projection#setGetPointResolution} to change an existing
     * projection object.
     * @param {ol.ProjectionLike} projection The projection.
     * @param {number} resolution Nominal resolution in projection units.
     * @param {ol.Coordinate} point Point to find adjusted resolution at.
     * @param {ol.proj.Units=} opt_units Units to get the point resolution in.
     * Default is the projection's units.
     * @return {number} Point resolution.
     * @api
     */
    ol.proj.getPointResolution = function(projection, resolution, point, opt_units) {
      projection = ol.proj.get(projection);
      var pointResolution;
      var getter = projection.getPointResolutionFunc();
      if (getter) {
        pointResolution = getter(resolution, point);
      } else {
        var units = projection.getUnits();
        if (units == ol.proj.Units.DEGREES && !opt_units || opt_units == ol.proj.Units.DEGREES) {
          pointResolution = resolution;
        } else {
          // Estimate point resolution by transforming the center pixel to EPSG:4326,
          // measuring its width and height on the normal sphere, and taking the
          // average of the width and height.
          var toEPSG4326 = ol.proj.getTransformFromProjections(projection, ol.proj.get('EPSG:4326'));
          var vertices = [
            point[0] - resolution / 2, point[1],
            point[0] + resolution / 2, point[1],
            point[0], point[1] - resolution / 2,
            point[0], point[1] + resolution / 2
          ];
          vertices = toEPSG4326(vertices, vertices, 2);
          var width = ol.proj.SPHERE_.haversineDistance(
              vertices.slice(0, 2), vertices.slice(2, 4));
          var height = ol.proj.SPHERE_.haversineDistance(
              vertices.slice(4, 6), vertices.slice(6, 8));
          pointResolution = (width + height) / 2;
          var metersPerUnit = opt_units ?
            ol.proj.Units.METERS_PER_UNIT[opt_units] :
            projection.getMetersPerUnit();
          if (metersPerUnit !== undefined) {
            pointResolution /= metersPerUnit;
          }
        }
      }
      return pointResolution;
    };

    /**
     * Registers transformation functions that don't alter coordinates. Those allow
     * to transform between projections with equal meaning.
     *
     * @param {Array.<ol.proj.Projection>} projections Projections.
     * @api
     */
    ol.proj.addEquivalentProjections = function(projections) {
      ol.proj.addProjections(projections);
      projections.forEach(function(source) {
        projections.forEach(function(destination) {
          if (source !== destination) {
            ol.proj.transforms.add(source, destination, ol.proj.cloneTransform);
          }
        });
      });
    };

    /**
     * Registers transformation functions to convert coordinates in any projection
     * in projection1 to any projection in projection2.
     *
     * @param {Array.<ol.proj.Projection>} projections1 Projections with equal
     *     meaning.
     * @param {Array.<ol.proj.Projection>} projections2 Projections with equal
     *     meaning.
     * @param {ol.TransformFunction} forwardTransform Transformation from any
     *   projection in projection1 to any projection in projection2.
     * @param {ol.TransformFunction} inverseTransform Transform from any projection
     *   in projection2 to any projection in projection1..
     */
    ol.proj.addEquivalentTransforms = function(projections1, projections2, forwardTransform, inverseTransform) {
      projections1.forEach(function(projection1) {
        projections2.forEach(function(projection2) {
          ol.proj.transforms.add(projection1, projection2, forwardTransform);
          ol.proj.transforms.add(projection2, projection1, inverseTransform);
        });
      });
    };

    /**
     * Add a Projection object to the list of supported projections that can be
     * looked up by their code.
     *
     * @param {ol.proj.Projection} projection Projection instance.
     * @api
     */
    ol.proj.addProjection = function(projection) {
      ol.proj.projections.add(projection.getCode(), projection);
      ol.proj.transforms.add(projection, projection, ol.proj.cloneTransform);
    };

    /**
     * @param {Array.<ol.proj.Projection>} projections Projections.
     */
    ol.proj.addProjections = function(projections) {
      projections.forEach(ol.proj.addProjection);
    };

    /**
     * Clear all cached projections and transforms.
     */
    ol.proj.clearAllProjections = function() {
      ol.proj.projections.clear();
      ol.proj.transforms.clear();
    };

    /**
     * @param {ol.proj.Projection|string|undefined} projection Projection.
     * @param {string} defaultCode Default code.
     * @return {ol.proj.Projection} Projection.
     */
    ol.proj.createProjection = function(projection, defaultCode) {
      if (!projection) {
        return ol.proj.get(defaultCode);
      } else if (typeof projection === 'string') {
        return ol.proj.get(projection);
      } else {
        return /** @type {ol.proj.Projection} */ (projection);
      }
    };

    /**
     * Registers coordinate transform functions to convert coordinates between the
     * source projection and the destination projection.
     * The forward and inverse functions convert coordinate pairs; this function
     * converts these into the functions used internally which also handle
     * extents and coordinate arrays.
     *
     * @param {ol.ProjectionLike} source Source projection.
     * @param {ol.ProjectionLike} destination Destination projection.
     * @param {function(ol.Coordinate): ol.Coordinate} forward The forward transform
     *     function (that is, from the source projection to the destination
     *     projection) that takes a {@link ol.Coordinate} as argument and returns
     *     the transformed {@link ol.Coordinate}.
     * @param {function(ol.Coordinate): ol.Coordinate} inverse The inverse transform
     *     function (that is, from the destination projection to the source
     *     projection) that takes a {@link ol.Coordinate} as argument and returns
     *     the transformed {@link ol.Coordinate}.
     * @api
     */
    ol.proj.addCoordinateTransforms = function(source, destination, forward, inverse) {
      var sourceProj = ol.proj.get(source);
      var destProj = ol.proj.get(destination);
      ol.proj.transforms.add(sourceProj, destProj,
          ol.proj.createTransformFromCoordinateTransform(forward));
      ol.proj.transforms.add(destProj, sourceProj,
          ol.proj.createTransformFromCoordinateTransform(inverse));
    };

    /**
     * Creates a {@link ol.TransformFunction} from a simple 2D coordinate transform
     * function.
     * @param {function(ol.Coordinate): ol.Coordinate} transform Coordinate
     *     transform.
     * @return {ol.TransformFunction} Transform function.
     */
    ol.proj.createTransformFromCoordinateTransform = function(transform) {
      return (
        /**
         * @param {Array.<number>} input Input.
         * @param {Array.<number>=} opt_output Output.
         * @param {number=} opt_dimension Dimension.
         * @return {Array.<number>} Output.
         */
        function(input, opt_output, opt_dimension) {
          var length = input.length;
          var dimension = opt_dimension !== undefined ? opt_dimension : 2;
          var output = opt_output !== undefined ? opt_output : new Array(length);
          var point, i, j;
          for (i = 0; i < length; i += dimension) {
            point = transform([input[i], input[i + 1]]);
            output[i] = point[0];
            output[i + 1] = point[1];
            for (j = dimension - 1; j >= 2; --j) {
              output[i + j] = input[i + j];
            }
          }
          return output;
        });
    };

    /**
     * Transforms a coordinate from longitude/latitude to a different projection.
     * @param {ol.Coordinate} coordinate Coordinate as longitude and latitude, i.e.
     *     an array with longitude as 1st and latitude as 2nd element.
     * @param {ol.ProjectionLike=} opt_projection Target projection. The
     *     default is Web Mercator, i.e. 'EPSG:3857'.
     * @return {ol.Coordinate} Coordinate projected to the target projection.
     * @api
     */
    ol.proj.fromLonLat = function(coordinate, opt_projection) {
      return ol.proj.transform(coordinate, 'EPSG:4326',
          opt_projection !== undefined ? opt_projection : 'EPSG:3857');
    };

    /**
     * Transforms a coordinate to longitude/latitude.
     * @param {ol.Coordinate} coordinate Projected coordinate.
     * @param {ol.ProjectionLike=} opt_projection Projection of the coordinate.
     *     The default is Web Mercator, i.e. 'EPSG:3857'.
     * @return {ol.Coordinate} Coordinate as longitude and latitude, i.e. an array
     *     with longitude as 1st and latitude as 2nd element.
     * @api
     */
    ol.proj.toLonLat = function(coordinate, opt_projection) {
      return ol.proj.transform(coordinate,
          opt_projection !== undefined ? opt_projection : 'EPSG:3857', 'EPSG:4326');
    };

    /**
     * Fetches a Projection object for the code specified.
     *
     * @param {ol.ProjectionLike} projectionLike Either a code string which is
     *     a combination of authority and identifier such as "EPSG:4326", or an
     *     existing projection object, or undefined.
     * @return {ol.proj.Projection} Projection object, or null if not in list.
     * @api
     */
    ol.proj.get = function(projectionLike) {
      var projection = null;
      if (projectionLike instanceof ol.proj.Projection) {
        projection = projectionLike;
      } else if (typeof projectionLike === 'string') {
        var code = projectionLike;
        projection = ol.proj.projections.get(code);
        Iif (ol.ENABLE_PROJ4JS && !projection) {
          var proj4js = ol.proj.proj4.get();
          if (typeof proj4js == 'function' &&
              proj4js.defs(code) !== undefined) {
            projection = new ol.proj.Projection({code: code});
            ol.proj.addProjection(projection);
          }
        }
      }
      return projection;
    };

    /**
     * Checks if two projections are the same, that is every coordinate in one
     * projection does represent the same geographic point as the same coordinate in
     * the other projection.
     *
     * @param {ol.proj.Projection} projection1 Projection 1.
     * @param {ol.proj.Projection} projection2 Projection 2.
     * @return {boolean} Equivalent.
     * @api
     */
    ol.proj.equivalent = function(projection1, projection2) {
      if (projection1 === projection2) {
        return true;
      }
      var equalUnits = projection1.getUnits() === projection2.getUnits();
      if (projection1.getCode() === projection2.getCode()) {
        return equalUnits;
      } else {
        var transformFn = ol.proj.getTransformFromProjections(
            projection1, projection2);
        return transformFn === ol.proj.cloneTransform && equalUnits;
      }
    };

    /**
     * Given the projection-like objects, searches for a transformation
     * function to convert a coordinates array from the source projection to the
     * destination projection.
     *
     * @param {ol.ProjectionLike} source Source.
     * @param {ol.ProjectionLike} destination Destination.
     * @return {ol.TransformFunction} Transform function.
     * @api
     */
    ol.proj.getTransform = function(source, destination) {
      var sourceProjection = ol.proj.get(source);
      var destinationProjection = ol.proj.get(destination);
      return ol.proj.getTransformFromProjections(
          sourceProjection, destinationProjection);
    };

    /**
     * Searches in the list of transform functions for the function for converting
     * coordinates from the source projection to the destination projection.
     *
     * @param {ol.proj.Projection} sourceProjection Source Projection object.
     * @param {ol.proj.Projection} destinationProjection Destination Projection
     *     object.
     * @return {ol.TransformFunction} Transform function.
     */
    ol.proj.getTransformFromProjections = function(sourceProjection, destinationProjection) {
      var sourceCode = sourceProjection.getCode();
      var destinationCode = destinationProjection.getCode();
      var transform = ol.proj.transforms.get(sourceCode, destinationCode);
      Iif (ol.ENABLE_PROJ4JS && !transform) {
        var proj4js = ol.proj.proj4.get();
        if (typeof proj4js == 'function') {
          var sourceDef = proj4js.defs(sourceCode);
          var destinationDef = proj4js.defs(destinationCode);

          if (sourceDef !== undefined && destinationDef !== undefined) {
            if (sourceDef === destinationDef) {
              ol.proj.addEquivalentProjections([destinationProjection, sourceProjection]);
            } else {
              var proj4Transform = proj4js(destinationCode, sourceCode);
              ol.proj.addCoordinateTransforms(destinationProjection, sourceProjection,
                  proj4Transform.forward, proj4Transform.inverse);
            }
            transform = ol.proj.transforms.get(sourceCode, destinationCode);
          }
        }
      }
      Iif (!transform) {
        transform = ol.proj.identityTransform;
      }
      return transform;
    };

    /**
     * @param {Array.<number>} input Input coordinate array.
     * @param {Array.<number>=} opt_output Output array of coordinate values.
     * @param {number=} opt_dimension Dimension.
     * @return {Array.<number>} Input coordinate array (same array as input).
     */
    ol.proj.identityTransform = function(input, opt_output, opt_dimension) {
      if (opt_output !== undefined && input !== opt_output) {
        for (var i = 0, ii = input.length; i < ii; ++i) {
          opt_output[i] = input[i];
        }
        input = opt_output;
      }
      return input;
    };

    /**
     * @param {Array.<number>} input Input coordinate array.
     * @param {Array.<number>=} opt_output Output array of coordinate values.
     * @param {number=} opt_dimension Dimension.
     * @return {Array.<number>} Output coordinate array (new array, same coordinate
     *     values).
     */
    ol.proj.cloneTransform = function(input, opt_output, opt_dimension) {
      var output;
      if (opt_output !== undefined) {
        for (var i = 0, ii = input.length; i < ii; ++i) {
          opt_output[i] = input[i];
        }
        output = opt_output;
      } else {
        output = input.slice();
      }
      return output;
    };

    /**
     * Transforms a coordinate from source projection to destination projection.
     * This returns a new coordinate (and does not modify the original).
     *
     * See {@link ol.proj.transformExtent} for extent transformation.
     * See the transform method of {@link ol.geom.Geometry} and its subclasses for
     * geometry transforms.
     *
     * @param {ol.Coordinate} coordinate Coordinate.
     * @param {ol.ProjectionLike} source Source projection-like.
     * @param {ol.ProjectionLike} destination Destination projection-like.
     * @return {ol.Coordinate} Coordinate.
     * @api
     */
    ol.proj.transform = function(coordinate, source, destination) {
      var transformFn = ol.proj.getTransform(source, destination);
      return transformFn(coordinate, undefined, coordinate.length);
    };

    /**
     * Transforms an extent from source projection to destination projection.  This
     * returns a new extent (and does not modify the original).
     *
     * @param {ol.Extent} extent The extent to transform.
     * @param {ol.ProjectionLike} source Source projection-like.
     * @param {ol.ProjectionLike} destination Destination projection-like.
     * @return {ol.Extent} The transformed extent.
     * @api
     */
    ol.proj.transformExtent = function(extent, source, destination) {
      var transformFn = ol.proj.getTransform(source, destination);
      return ol.extent.applyTransform(extent, transformFn);
    };

    /**
     * Transforms the given point to the destination projection.
     *
     * @param {ol.Coordinate} point Point.
     * @param {ol.proj.Projection} sourceProjection Source projection.
     * @param {ol.proj.Projection} destinationProjection Destination projection.
     * @return {ol.Coordinate} Point.
     */
    ol.proj.transformWithProjections = function(point, sourceProjection, destinationProjection) {
      var transformFn = ol.proj.getTransformFromProjections(
          sourceProjection, destinationProjection);
      return transformFn(point);
    };

    /**
     * Add transforms to and from EPSG:4326 and EPSG:3857.  This function is called
     * by when this module is executed and should only need to be called again after
     * `ol.proj.clearAllProjections()` is called (e.g. in tests).
     */
    ol.proj.addCommon = function() {
      // Add transformations that don't alter coordinates to convert within set of
      // projections with equal meaning.
      ol.proj.addEquivalentProjections(ol.proj.EPSG3857.PROJECTIONS);
      ol.proj.addEquivalentProjections(ol.proj.EPSG4326.PROJECTIONS);
      // Add transformations to convert EPSG:4326 like coordinates to EPSG:3857 like
      // coordinates and back.
      ol.proj.addEquivalentTransforms(
          ol.proj.EPSG4326.PROJECTIONS,
          ol.proj.EPSG3857.PROJECTIONS,
          ol.proj.EPSG3857.fromEPSG4326,
          ol.proj.EPSG3857.toEPSG4326);
    };

    ol.proj.addCommon();